package com.zsw.starter.handler;

import io.netty.buffer.ByteBuf;
import io.netty.channel.ChannelHandlerContext;
import io.netty.channel.SimpleChannelInboundHandler;
import lombok.extern.slf4j.Slf4j;

import java.nio.charset.StandardCharsets;


@Slf4j
public class ClientHandler extends SimpleChannelInboundHandler<ByteBuf> {
    int i ;
    public ClientHandler(int i) {
        this.i = i;
    }

    @Override
    protected void channelRead0(ChannelHandlerContext channelHandlerContext, ByteBuf byteBuf) throws Exception {
        String channelId = channelHandlerContext.channel().id().toString();
        byte[] bytes = new byte[byteBuf.readableBytes()];
        byteBuf.getBytes(byteBuf.readerIndex(), bytes);
        String info = new String(bytes, StandardCharsets.UTF_8);
        log.info("info:{}",info);
    }

    @Override
    public void channelActive(ChannelHandlerContext ctx) throws Exception {
        super.channelActive(ctx);
        log.info("客户端连接:{}",ctx.channel().id());
        ctx.writeAndFlush("ctx-"+i);
    }
}
