package com.zsw.starter.handler;

import cn.hutool.core.util.StrUtil;
import io.netty.buffer.ByteBuf;
import io.netty.channel.ChannelHandlerContext;
import io.netty.channel.ChannelId;
import io.netty.channel.SimpleChannelInboundHandler;
import lombok.Synchronized;
import lombok.extern.slf4j.Slf4j;

import java.io.OutputStream;
import java.io.OutputStreamWriter;
import java.net.Socket;
import java.nio.charset.StandardCharsets;


@Slf4j
public class ServerHandler extends SimpleChannelInboundHandler<ByteBuf> {
    protected void channelRead0(ChannelHandlerContext channelHandlerContext, ByteBuf byteBuf) throws Exception {

        String channelId = channelHandlerContext.channel().id().toString();
        byte[] bytes = new byte[byteBuf.readableBytes()];
        byteBuf.getBytes(byteBuf.readerIndex(), bytes);
        String info = new String(bytes, StandardCharsets.UTF_8);
        log.info("channelHandlerContext:{}",channelHandlerContext.channel().id());
        test(channelHandlerContext.channel().id());

        // Thread.sleep(5000L);
        Socket socket = new Socket("192.168.10.188", 9100);
        OutputStream socketOut = socket.getOutputStream();
        OutputStreamWriter writer = new OutputStreamWriter(socketOut, "GBK");
        socketOut.write(27);
        socketOut.write(27);
        String str = StrUtil.format("ctx:{},text:{}\n",channelHandlerContext.channel().id(),info);
        writer.write(str);
        writer.flush();

        writer.write(27);
        writer.write(100);
        writer.write(4);
        writer.write(10);
        writer.flush();

        writer.write(0x1D);
        writer.write("V");
        writer.write(48);
        writer.write(0);
        writer.flush();

        log.info("停止5秒后完成");
        socket.close();
        writer.close();
        socketOut.close();
    }


    private synchronized  void test(ChannelId id){
        log.info("测试同步开始...{}",id);
    }


}
